#include "gb.c"
#include "gbmPr2.c"

void gbmPr2_direct_mini(Gb_q7* Q, double a1, double r3, double r5, Gb_th* th07)
{

  double C1 = cos (Q->q1);
  double C2 = cos (Q->q2);
  double C3 = cos (Q->q3);
  double C4 = cos (Q->q4);
  double C5 = cos (Q->q5);
  double C6 = cos (Q->q6);
  double C7 = cos (Q->q7);
  double S1 = sin (Q->q1);
  double S2 = sin (Q->q2);
  double S3 = sin (Q->q3);
  double S4 = sin (Q->q4);
  double S5 = sin (Q->q5);
  double S6 = sin (Q->q6);
  double S7 = sin (Q->q7);

  double  d1= C6 * C7;
  double  d2= S6 * C7;

  double  d3= C5 * d1 - S5 * S7;
  double  d4=-S5 * d1 - C5 * S7 ;
  double  d5=-C5 * S6;
  double  d6= S5 * S6;

  double  d7= C4 * d3 - S4 * d2;
  double  d8= S4 * d3 + C4 * d2;
  double  d9= C4 * d5 - S4 * C6;
  double d10= S4 * d5 + C4 * C6;
  double d11=-S4 * r5;
  double d12= C4 * r5;

  double d13= C3 * d7 + S3 * d4;
  double d14=-S3 * d7 + C3 * d4;
  double d15= C3 * d9 + S3 * d6;
  double d16=-S3 * d9 + C3 * d6;
  double d17= C3 * d11;
  double d18=-S3 * d11;

  double d19= C2 * d13 - S2 * d8;
  double d20=-S2 * d13 - C2 * d8;
  double d21= C2 * d15 - S2 * d10;
  double d22=-S2 * d15 - C2 * d10;
  double d23= C2 * d17 - S2 *(d12+r3)+a1;
  double d24=-S2 * d17 - C2 *(d12+r3);

  double d25= C1 * d19 - S1 * d14;
  double d26= S1 * d19 + C1 * d14;
  double d27= C1 * d21 - S1 * d16;
  double d28= S1 * d21 + C1 * d16;
  double d29= C1 * d23 - S1 * d18;
  double d30= S1 * d23 + C1 * d18;

  th07->vx.x = d25;
  th07->vx.y = d26;
  th07->vx.z = d20;
  th07->vy.x = d28*d20-d22*d26;
  th07->vy.y = d22*d25-d27*d20;
  th07->vy.z = d27*d26-d28*d25;
  th07->vz.x = d27;
  th07->vz.y = d28;
  th07->vz.z = d22;
  th07->vp.x = d29;
  th07->vp.y = d30;
  th07->vp.z = d24;
}


int local_test()
{
  // Gb_q7 Q = {-1.546444, 1.204801, -3.699798, -2.162888, -2.518028, -2.006384, 2.640556 };
  Gb_q7 Q = {-M_PI/4, M_PI/2,-M_PI/2,    -M_PI/2, M_PI/2, 0,  M_PI/2};
  //Gb_q7 Q = { 0,0,0, 0,0,0, 0};
  //double a1 = 0.1;
  //double r3 = 0.4;
  //double r5 = 0.5;
  double a1=0.1;
  double r3=0.4;  
  double r5=0.321;
  Gb_th th07;
  Gb_jac7 jac7;
//  gbmPr2_direct(&Q, a1, r3, r5, &th07, &jac7);
//  Gb_q7_print(&Q, "Q");
//  Gb_th_print(&th07, "th_07");
  //  gbmPr2_direct_mini(&Q, a1, r3, r5, &th07);
  //  Gb_th_print(&th07, "th_07 mini");

  Gb_statusMGI status;
  Gb_q7 Qc;
  Gb_q7 qMin = {-1e5, -1e5, -1e5, -1e5, -1e5, -1e5, -1e5};
  Gb_q7 qMax = { 1e5,  1e5,  1e5,  1e5,  1e5,  1e5,  1e5};
  Gb_q7 qsol[32];
  int nbsolution;
///  status = pr2_mgi_q3_8(&th07, &Q, a1, r3, r5, &qMin, &qMax, 
///			1E-7, qsol, &nbsolution);
///  printf("status= %s  nbsolution= %d\n", gbM_Gb_statusMGI_string(status), nbsolution);
///  for (int i=0; i < nbsolution; i++) {
///    printf("solution %d\n", i+1);
///    Gb_q7_print(&(qsol[i]), "sol");
///  }
//  printf("--++--*--++--\n");
//  Gb_q7 QQ1 = { 0.000000, 1.570796, 0.000000, 0.000000, 3.141593, 1.570796, 0.000000};
//  Gb_q7 QQ2 = { 0.000000, 1.570796, 0.000000, 0.000000, 0.000000,-1.570796, 3.141593};
//  Gb_q7 QQ3 = { 0.000000, 0       , 0.000000, 0.000000, 0.000000,-1.570796, 3.141593};
//  gbmPr2_direct(&QQ3, a1, r3, r5, &th07, &jac7);
//  Gb_q7_print(&QQ3, "Q");
//  Gb_th_print(&th07, "th_07");
//  printf("--++--*--++--\n");

  int e1, e2, e3, e4;
  double delta_q1;
  Gb_q7 qNew;
  Gb_q7 Q2 = { -2.0, -0.5, 0.4, -0.3, 2., -1., -3. };
  //  Gb_q7 Q2 = { 0,0,0, 0,0,0, 0};
  gbmPr2_direct(&Q2, a1, r3, r5, &th07, &jac7);
  Gb_q7_print(&Q2, "Q2");
  Gb_th_print(&th07, "th_07");
  gbMPr2_gete1e2e3e4(&Q2, &th07,   &e1, &e2, &e3, &e4, &delta_q1);
  printf("e1= %d, e2= %d, e3= %d, e4= %d, delta_q1= %g\n", e1, e2, e3, e4, delta_q1);
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, e1, e2, e3, e4, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1, 1, 1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1, 1, 1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1, 1,-1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1, 1,-1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1,-1, 1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1,-1, 1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1,-1,-1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2, 1,-1,-1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1, 1, 1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1, 1, 1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1, 1,-1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1, 1,-1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1,-1, 1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1,-1, 1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1,-1,-1, 1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &Q2,-1,-1,-1,-1, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  Gb_q7_print(&qNew, "qNew");
  printf("gbMPr2_mgi_deltaQ1: status= %s\n", gbM_Gb_statusMGI_string(status));
  return(0);
  printf("---------2--------\n");
  //  Gb_q7 Q2 = { -2.059528, -0.521427, 0.431210, -0.325098, 2.316975, -1.282325, -2.647173 };
  //  Gb_q7 Q2 = { 0,0,0, 0,0,0, 0};
  //    Gb_q7 Q2 = { 0,-M_PI/2,0, 0,0,0, 0};
    //Gb_q7 Q2 = { 0,M_PI,0, 0,0,0, 0};
  gbmPr2_direct(&Q2, a1, r3, r5, &th07, &jac7);
  status = pr2_mgi_q3_8(&th07, &Q2, a1, r3, r5, &qMin, &qMax, 
			1E-7, qsol, &nbsolution);
  Gb_q7_print(&Q2, "Q");
  Gb_th_print(&th07, "th_07");
  printf("status= %s  nbsolution= %d\n", gbM_Gb_statusMGI_string(status), nbsolution);
  for (int i=0; i < nbsolution; i++) {
    printf("solution %d\n", i+1);
    Gb_q7_print(&(qsol[i]), "sol");
    gbmPr2_direct(&Q, a1, r3, r5, &th07, &jac7);
    Gb_th_print(&th07, "th_07");
  }
}

int find_offset()
{
  Gb_q7 Q = {-M_PI/4, M_PI/2,-M_PI/2,    -M_PI/2, M_PI/2, 0,  M_PI/2};
  double a1=0.1;
  double r3=0.4;  
  double r5=0.321;
  Gb_th th07;
  th07.vx.x = 1;
  th07.vx.y = 0;
  th07.vx.z = 0;
  th07.vy.x = 0;
  th07.vy.y = 1;
  th07.vy.z = 0;
  th07.vz.x = 0;
  th07.vz.y = 0;
  th07.vz.z = 1;
  th07.vp.x = a1+r3+r5;
  th07.vp.y = 0;
  th07.vp.z = 0;
  Gb_jac7 jac7;
//  gbmPr2_direct(&Q, a1, r3, r5, &th07, &jac7);
//  Gb_q7_print(&Q, "Q");
  Gb_th_print(&th07, "th_07");

  Gb_statusMGI status;
  //  Gb_q7 qMin = {-1e5, -1e5, -1e5, -1e5, -1e5, -1e5, -1e5};
  //  Gb_q7 qMax = { 1e5,  1e5,  1e5,  1e5,  1e5,  1e5,  1e5};
  Gb_q7 qMin = {-2.2853981634,-0.5236, -3.9,   -2.3213, -1e5, -2.18, -1e5};
  Gb_q7 qMax = { 0.7146018366, 1.3963,  0.8,         0,  1e5,     0,  1e5};
  Gb_q7 qsol[32], qNew;
  int nbsolution;
  status = pr2_mgi_q3_8(&th07, &Q, a1, r3, r5, &qMin, &qMax, 1E-7, qsol, &nbsolution);
  printf("status= %s  nbsolution= %d\n", gbM_Gb_statusMGI_string(status), nbsolution);
  //  Gb_q7_print(&(qsol[0]), "sol");
  for (int i=0; i < nbsolution; i++) {
    printf("solution %d\n", i+1);
    Gb_q7_print(&(qsol[i]), "sol");
  }
  printf("-----delta_q1-----\n");
  int e1, e2, e3, e4;
  double delta_q1;
//  Gb_th th78, th87, thd07;
//  th78.vx.x = 0;
//  th78.vx.y = 0;
//  th78.vx.z = 1;
//  th78.vy.x = 0;
//  th78.vy.y = -1;
//  th78.vy.z = 0;
//  th78.vz.x = 1;
//  th78.vz.y = 0;
//  th78.vz.z = 0;
//  th78.vp.x = 0;
//  th78.vp.y = 0;
//  th78.vp.z = 0;
//  Gb_th_print(&th78, "th78");
//  Gb_th_inverse(&th78, &th87);
//  Gb_th_print(&th87, "th87");
//  Gb_th_produit(&th07, &th87, &thd07);
//  Gb_th_print(&thd07, "thd07");
//  // T08 = T07 * T78   --->  T07 = T08 * T87
//  qsol[0].q2 = qsol[0].q2 - M_PI/2;
  gbMPr2_gete1e2e3e4(&(qsol[0]), &th07,   &e1, &e2, &e3, &e4, &delta_q1);
  printf("e1= %d, e2= %d, e3= %d, e4= %d, delta_q1= %g\n", e1, e2, e3, e4, delta_q1);
  status = gbMPr2_mgi_deltaQ1(&th07, delta_q1, &(qsol[0]), e1, e2, e3, e4, a1, r3, r5, 1e-6, &qMin, &qMax, &qNew);
  //  qNew.q2 += M_PI/2;
  Gb_q7_print(&qNew, "qNew");
  return(0);
}

void solvePb()
{
  int e1, e2, e3, e4;
  double a1 = 0.1;
  double r3 = 0.4;
  double r5 = 0.5;
  Gb_q7 q7, q_old, qNew, qNewPr2;
  Gb_th th07;
  Gb_jac7 jac7;
  double delta_q1;
  Gb_statusMGI status;

  Gb_q7 qMin = {-2.2853981634,-0.5236, -3.9,   -2.3213, -M_PI, -2.18, -M_PI};
  Gb_q7 qMax = { 0.7146018366, 1.3963,  0.8,         0,  M_PI,     0,  M_PI};

  printf("------------ pB -----------\n");
  Gb_q7 qPb = { -0.856103, 0.223844, -2.944723, -2.255433, 2.523789, -1.250236, -2.249248 };
  gbmPr2_direct(&qPb, a1, r3, r5, &th07, &jac7);
  status = gbMPr2_mgi_q3(&th07, &qPb, a1, r3, r5, &qMin, &qMax, 1e-7, &qNewPr2);
  printf("gbMPr2_mgi_deltaQ1: status= %s\n", gbM_Gb_statusMGI_string(status));
  Gb_q7_print(&qPb, "qPb");
  Gb_th_print(&th07, "th07");
  Gb_q7_print(&qNewPr2, "qNewPr2");
  printf("------------ pB -----------\n");
}

int main(int argc, char** argv)
{
  Gb_q7 qMin = {-2.2853981634,-0.5236, -3.9,   -2.3213, -M_PI, -2.18, -M_PI};
  Gb_q7 qMax = { 0.7146018366, 1.3963,  0.8,         0,  M_PI,     0,  M_PI};
  //  local_test();
  //printf("/////////////////////////////\n");
  //find_offset();
  // solvePb();  // --->> There is a real problem in gbMPr2_mgi_q3 : I don't know how to solve it.
  gbMPr2_mgi_test(&qMin, &qMax);
}
